<script>
import { requiredIf } from 'vuelidate/lib/validators';
import { error_message, success_message } from "../Helper/helper";
import { settingService } from '../services';
import dropzonePopup from './dropzone-popup.vue';
import config from '../config';
import { routes } from '../config/api_routes'


export default {
  name: 'pushnotification',
  props: ["notificationType"],
  components: { dropzonePopup },
  data() {
    return {
      config: config,
      openModal: false,
      owner_pem_delete_url: routes.removeIOSPemApi,
      setting: {
        customer_pem: '',
        owner_pem: '',
        driver_pem: '',
        notification_server_key: '',
        sendgrid_key: '',
        // isActiveSandgrid:false,
        // isActiveAndroidNotification:false,
        // isActiveIOSNotification:false
      },
      isLoading: true
    };
  },
  validations: {
    setting: {
      customer_pem: {
        required:requiredIf(function(){
          return this.notificationType == 'IOS';
        })
      },
      owner_pem: {
        required:requiredIf(function(){
          return this.notificationType == 'IOS';
        })
      },
      driver_pem: {
        required:requiredIf(function(){
          return this.notificationType == 'IOS';
        })
      },
      notification_server_key: {
        required:requiredIf(function(){
          return this.notificationType == 'Android';
        })
      },
      sendgrid_key: {
        required:requiredIf(function(){
          return this.notificationType == 'sandgrid';
        })
      },
    },
  },
  mounted() {
    this.getSetting();
    this.openModal = true
  },

  methods: {
    getSetting() {
      settingService.getSetting().then((response) => {
        if (response.data.code === 200) {
          this.isLoading = false;
          this.setting.customer_pem = response.data.result.customer_pem ?? '',
          this.setting.owner_pem = response.data.result.owner_pem ?? '',
          this.setting.driver_pem = response.data.result.driver_pem ?? '',
          this.setting.notification_server_key = response.data.result.notification_server_key ?? '',
          this.setting.sendgrid_key = response.data.result.sendgrid_key ?? ''
          this.customer_pem_image = response.data.result.customer_pem ?? ''
          this.owner_pem_image = response.data.result.owner_pem ?? ''
          this.driver_pem_image = response.data.result.driver_pem ?? ''
        } else {
          this.isLoading = false;
          error_message(response.data.message);
        }
      })
    },

    onCustomerPemdeleted(key) {
      settingService.deleteGeneralSettingByKey({ key: key }).then((response) => {
        if (response.data.code === 200) {
          this.getSetting()
        } else {
          error_message(response.data.message);
        }
      });
    },

    modalClose(e) {
      this.openModal = false;      
      this.$emit('isModalClose', false)
    },

    fromSubmit() {
      if(this.notificationType == 'Android') {
        this.setting.isActiveAndroidNotification = true;
      }else if(this.notificationType == 'IOS') {
        this.setting.isActiveIOSNotification = true;
      }else if(this.notificationType == 'sandgrid') {
        this.setting.isActiveSandgrid = true;
      }      
      this.$v.setting.$touch();
      if (this.$v.setting.$invalid) {
        return false;
      } else {        
        settingService.updateSetting({ data: this.setting }).then((response) => {
          if (response.data.code === 200) {
            success_message(response.data.message);
            this.openModal = false;
            this.$emit('modalClose', false)
          } else {
            error_message(response.data.message);
          }
        })
      }
    },
  },
};
</script>
<template>
  <div>
    <b-modal v-model="openModal" hide-footer scrollable no-close-on-backdrop
      :title="(notificationType =='sandgrid')? trans.get('__JSON__.SandGrid') :trans.get('__JSON__.Push Notifications')" title-class="font-18" @hidden="modalClose" centered size="lg">
      <template v-if="isLoading">
        <div class="text-center text-danger my-2">
          <b-spinner class="align-middle"></b-spinner>
          <strong>{{ trans.get('__JSON__.Loading...') }}</strong>
        </div>
      </template>
      <template v-else>
        <form @submit.prevent="fromSubmit" id="formData">
          <!-- Push Notifications -->
          <div class="row"  v-if="notificationType == 'IOS'">
            <div class="col-md-12">
              <h6>{{ trans.get('__JSON__.Pem Files (iOS Application)') }}</h6>
            </div>
            <div class="row col-md-12">
              <div class="col-md-12">
                <div class="row mt-3">
                  <div class="col-md-4">
                    <p class="ml-3">{{ trans.get('__JSON__.Customer Application') }}</p>
                    <dropzone-popup :readonly="!$auth.hasPermission(config.permissions.setting_Write)"
                      v-model="setting.customer_pem" id="customer_pem" acceptedFiles=".pem" deleted_dialog="yes"
                      :pem-delete="true" :media-path="setting.pem_url" :delete-path="owner_pem_delete_url"
                      @image-deleted="onCustomerPemdeleted('customer_pem')"
                      :class="{ 'is-invalid': $v.setting.customer_pem.$error }" />
                    <div v-if="$v.setting.customer_pem.$error" class="invalid-feedback">
                      <span v-if="!$v.setting.customer_pem.required">
                        {{ trans.get('__JSON__.This field is required') }}
                      </span>
                    </div>
                  </div>
                  <div class="col-md-4">
                    <p class="ml-3">{{ trans.get('__JSON__.Merchant Application') }}</p>
                    <dropzone-popup :readonly="!$auth.hasPermission(config.permissions.setting_Write)"
                      v-model="setting.owner_pem" id="owner_pem" acceptedFiles=".pem" deleted_dialog="yes"
                      :pem-delete="true" :media-path="setting.pem_url" :delete-path="owner_pem_delete_url"
                      @image-deleted="onCustomerPemdeleted('owner_pem')"
                      :class="{ 'is-invalid': $v.setting.owner_pem.$error }" />
                    <div v-if="$v.setting.owner_pem.$error" class="invalid-feedback">
                      <span v-if="!$v.setting.owner_pem.required">{{ trans.get('__JSON__.This field is required') }}</span>
                    </div>
                  </div>
                  <div class="col-md-4">
                    <p class="ml-3">{{ trans.get('__JSON__.Driver Application') }}</p>
                    <dropzone-popup :readonly="!$auth.hasPermission(config.permissions.setting_Write)"
                      v-model="setting.driver_pem" id="driver_pem" acceptedFiles=".pem" deleted_dialog="yes"
                      :pem-delete="true" :delete-path="owner_pem_delete_url"
                      @image-deleted="onCustomerPemdeleted('driver_pem')"
                      :class="{ 'is-invalid': $v.setting.driver_pem.$error }" />
                    <div v-if="$v.setting.driver_pem.$error" class="invalid-feedback">
                      <span v-if="!$v.setting.driver_pem.required">{{ trans.get('__JSON__.This field is required') }}</span>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>          
          <!-- Notification Server Key (Android) -->
          <div class="row" v-if="notificationType == 'Android'">
            <div class="col-md-12">
              <div class="row mt-3" >
                <div class="col-md-12">
                  <h6>{{ trans.get('__JSON__.Notification Server Key (Android)') }}</h6>
                </div>
                <div class="col-md-6">
                  <input type="text" class="form-control" v-model="setting.notification_server_key" :class="{ 'is-invalid': $v.setting.notification_server_key.$error }" />
                  <div v-if="$v.setting.notification_server_key.$error" class="invalid-feedback">
                    <span v-if="!$v.setting.notification_server_key.required">
                      {{ trans.get('__JSON__.This field is required') }}
                    </span>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- mail Setup -->
          <div class="row" v-if="notificationType == 'sandgrid'">
            <div class="col-md-12">
              <div class="row mt-3" >
                <div class="col-md-12">
                  <h6>{{ trans.get('__JSON__.Mail Setup') }}</h6>
                </div>
                <div class="col-md-6">
                  <input type="text" class="form-control" v-model="setting.sendgrid_key" :class="{ 'is-invalid': $v.setting.sendgrid_key.$error }" />
                  <div v-if="$v.setting.sendgrid_key.$error" class="invalid-feedback">
                    <span v-if="!$v.setting.sendgrid_key.required"> {{ trans.get('__JSON__.This field is required') }}</span>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <hr>
          <div class="row">
            <div class="col-md-12">
              <div class="w-100">
                <b-button variant="primary" @click="fromSubmit" class="float-right add_item_">{{
                  trans.get("__JSON__.Save") }}</b-button>
                <b-button class="float-left" @click="modalClose($event)">{{ trans.get("__JSON__.Close") }}</b-button>
              </div>
            </div>
          </div>
        </form>
      </template>
    </b-modal>
  </div>
</template>
<style scoped>
.modal-header .close {
  display: none !important;
}
</style>